【线段树】Codeforces 767C Garland

C. Garland
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Once at New Year Dima had a dream in which he was presented a fairy garland. A garland is a set of lamps, some pairs of which are connected by wires. Dima remembered that each two lamps in the garland were connected directly or indirectly via some wires. Furthermore, the number of wires was exactly one less than the number of lamps.

There was something unusual about the garland. Each lamp had its own brightness which depended on the temperature of the lamp. Temperatures could be positive, negative or zero. Dima has two friends, so he decided to share the garland with them. He wants to cut two different wires so that the garland breaks up into three parts. Each part of the garland should shine equally, i. e. the sums of lamps' temperatures should be equal in each of the parts. Of course, each of the parts should be non-empty, i. e. each part should contain at least one lamp.

Help Dima to find a suitable way to cut the garland, or determine that this is impossible.

While examining the garland, Dima lifted it up holding by one of the lamps. Thus, each of the lamps, except the one he is holding by, is now hanging on some wire. So, you should print two lamp ids as the answer which denote that Dima should cut the wires these lamps are hanging on. Of course, the lamp Dima is holding the garland by can't be included in the answer.

Input

The first line contains single integer n (3 ≤ n ≤ 106) — the number of lamps in the garland.

Then n lines follow. The i-th of them contain the information about the i-th lamp: the number lamp ai, it is hanging on (and 0, if is there is no such lamp), and its temperature ti ( - 100 ≤ ti ≤ 100). The lamps are numbered from 1 to n.

Output

If there is no solution, print -1.

Otherwise print two integers — the indexes of the lamps which mean Dima should cut the wires they are hanging on. If there are multiple answers, print any of them.

Examples
Input
6
2 4
0 5
4 2
2 1
1 1
4 2
Output
1 4
Input
6
2 4
0 6
4 2
2 1
1 1
4 2
Output
-1
Note

The garland and cuts scheme for the first example:


题意:给你一个数,每个节点都有一个值,问你能不能切两刀,将这棵树切为价值相等的三部分。
比赛时因为对线段树的处理不够明朗,对dfs与bfs的应用不顾熟练,故放弃。应加强对树这一结构的处理练习。
题解:由下自上更新每个节点的值,遇到等于sum/3的,则切一刀,且其父节点不再加和该值等于sum/3的子节点的值,采用bfs遍历。
(用队列存储每个无子节点的节点,该节点的值如果被父亲节点累加后,则父亲节点的子叶数减1;)
遍历完全之后检查这样的节点的个数。如>=2,则存在这样的分解方式,并输出对应的结点序号,如果k<2,则不存在这样的分解方式,故输出-1;tip:在输入各个结点的值时更新sum,如果所有节点值的总和sum%3!=0,则直接输出-1,无需遍历。
代码出处: http://blog.csdn.net/sunmoonvocano/article/details/76213692
#include <cstdio>  
#include <queue>  
#include <map>  
#include <stack>  
#include <cstring>  
#include <algorithm>  
#include <iostream>  
using namespace std;  
const int maxn = 1e6+10;  
int up[maxn]; //记录节点挂在谁身上  
int dp[maxn]; //dp 温度  
int ans[maxn];  
int num[maxn]; //记录被挂次数  
queue <int> q;  
int main()  
{  
    int n;  
    int sum = 0;  
    scanf("%d",&n);  
    for(int i = 1; i<=n; i++)  
    {  
        int x,y;  
        scanf("%d%d",&x,&y);  
        up[i] = x;  
        dp[i] = y;  
        sum+=y ;  
        num[x]++;  
    }  
    if(sum%3)  
    {  
        printf("-1\n");  
        return 0;  
    }  
    for(int i = 1; i <= n; i++)  
        if(num[i] == 0) q.push(i);  
    int k = 0;  
    while(q.size())  
    {  
        int x = q.front();  
        int y = up[x];  
        q.pop();  
        num[y]--;  
        if(num[y]==0 && up[y]) //不要根节点  
            q.push(y);  
        if(dp[x] == sum/3)  
            ans[k++] = x;  
        else  
            dp[y] += dp[x];// 如果子树被去掉父亲节点不再dp他的值。  
    }  
    if(k >= 2)  printf("%d %d\n",ans[1],ans[0]);  
    else  printf("-1\n");  
    return 0;  
} 

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值